/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Indexes;
import de.ship.db.Keys;
import de.ship.db.enums.EnumAccesslevel;
import de.ship.db.tables.TCoreGroup.TCoreGroupPath;
import de.ship.db.tables.TCorePrivilege.TCorePrivilegePath;
import de.ship.db.tables.records.TCoreGroupprivilegeRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Index;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TCoreGroupprivilege extends TableImpl<TCoreGroupprivilegeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_core_groupprivilege</code>
     */
    public static final TCoreGroupprivilege T_CORE_GROUPPRIVILEGE = new TCoreGroupprivilege();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TCoreGroupprivilegeRecord> getRecordType() {
        return TCoreGroupprivilegeRecord.class;
    }

    /**
     * The column <code>common_dd.t_core_groupprivilege.lastchange</code>.
     */
    public final TableField<TCoreGroupprivilegeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_core_groupprivilege.pk</code>.
     */
    public final TableField<TCoreGroupprivilegeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_core_groupprivilege.fk_privilege</code>.
     */
    public final TableField<TCoreGroupprivilegeRecord, Integer> FK_PRIVILEGE = createField(DSL.name("fk_privilege"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_groupprivilege.fk_group</code>.
     */
    public final TableField<TCoreGroupprivilegeRecord, Integer> FK_GROUP = createField(DSL.name("fk_group"), SQLDataType.INTEGER.nullable(false), this, "");

    /**
     * The column <code>common_dd.t_core_groupprivilege.shippie_acl</code>.
     */
    public final TableField<TCoreGroupprivilegeRecord, EnumAccesslevel> SHIPPIE_ACL = createField(DSL.name("shippie_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.t_core_groupprivilege.shipdesigner_acl</code>.
     */
    public final TableField<TCoreGroupprivilegeRecord, EnumAccesslevel> SHIPDESIGNER_ACL = createField(DSL.name("shipdesigner_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.t_core_groupprivilege.square_acl</code>.
     */
    public final TableField<TCoreGroupprivilegeRecord, EnumAccesslevel> SQUARE_ACL = createField(DSL.name("square_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.t_core_groupprivilege.sam_acl</code>.
     */
    public final TableField<TCoreGroupprivilegeRecord, EnumAccesslevel> SAM_ACL = createField(DSL.name("sam_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    private TCoreGroupprivilege(Name alias, Table<TCoreGroupprivilegeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TCoreGroupprivilege(Name alias, Table<TCoreGroupprivilegeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_core_groupprivilege</code> table
     * reference
     */
    public TCoreGroupprivilege(String alias) {
        this(DSL.name(alias), T_CORE_GROUPPRIVILEGE);
    }

    /**
     * Create an aliased <code>common_dd.t_core_groupprivilege</code> table
     * reference
     */
    public TCoreGroupprivilege(Name alias) {
        this(alias, T_CORE_GROUPPRIVILEGE);
    }

    /**
     * Create a <code>common_dd.t_core_groupprivilege</code> table reference
     */
    public TCoreGroupprivilege() {
        this(DSL.name("t_core_groupprivilege"), null);
    }

    public <O extends Record> TCoreGroupprivilege(Table<O> path, ForeignKey<O, TCoreGroupprivilegeRecord> childPath, InverseForeignKey<O, TCoreGroupprivilegeRecord> parentPath) {
        super(path, childPath, parentPath, T_CORE_GROUPPRIVILEGE);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TCoreGroupprivilegePath extends TCoreGroupprivilege implements Path<TCoreGroupprivilegeRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TCoreGroupprivilegePath(Table<O> path, ForeignKey<O, TCoreGroupprivilegeRecord> childPath, InverseForeignKey<O, TCoreGroupprivilegeRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TCoreGroupprivilegePath(Name alias, Table<TCoreGroupprivilegeRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TCoreGroupprivilegePath as(String alias) {
            return new TCoreGroupprivilegePath(DSL.name(alias), this);
        }

        @Override
        public TCoreGroupprivilegePath as(Name alias) {
            return new TCoreGroupprivilegePath(alias, this);
        }

        @Override
        public TCoreGroupprivilegePath as(Table<?> alias) {
            return new TCoreGroupprivilegePath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public List<Index> getIndexes() {
        return Arrays.asList(Indexes.IDX_GROUPPRIVILEGE_GROUP, Indexes.IDX_GROUPPRIVILEGE_PRIVILEGE);
    }

    @Override
    public Identity<TCoreGroupprivilegeRecord, Integer> getIdentity() {
        return (Identity<TCoreGroupprivilegeRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TCoreGroupprivilegeRecord> getPrimaryKey() {
        return Keys.PK_CORE_GROUPPRIVILEGE;
    }

    @Override
    public List<UniqueKey<TCoreGroupprivilegeRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_CORE_GROUPPRIVILEGE);
    }

    @Override
    public List<ForeignKey<TCoreGroupprivilegeRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_CORE_GROUPPRIVILEGE__FK_CORE_GROUPPRIVILEGE_PRIVILEGE, Keys.T_CORE_GROUPPRIVILEGE__FK_CORE_GROUPPRIVILEGE_GROUP);
    }

    private transient TCorePrivilegePath _tCorePrivilege;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_privilege</code>
     * table.
     */
    public TCorePrivilegePath tCorePrivilege() {
        if (_tCorePrivilege == null)
            _tCorePrivilege = new TCorePrivilegePath(this, Keys.T_CORE_GROUPPRIVILEGE__FK_CORE_GROUPPRIVILEGE_PRIVILEGE, null);

        return _tCorePrivilege;
    }

    private transient TCoreGroupPath _tCoreGroup;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_group</code>
     * table.
     */
    public TCoreGroupPath tCoreGroup() {
        if (_tCoreGroup == null)
            _tCoreGroup = new TCoreGroupPath(this, Keys.T_CORE_GROUPPRIVILEGE__FK_CORE_GROUPPRIVILEGE_GROUP, null);

        return _tCoreGroup;
    }

    @Override
    public TCoreGroupprivilege as(String alias) {
        return new TCoreGroupprivilege(DSL.name(alias), this);
    }

    @Override
    public TCoreGroupprivilege as(Name alias) {
        return new TCoreGroupprivilege(alias, this);
    }

    @Override
    public TCoreGroupprivilege as(Table<?> alias) {
        return new TCoreGroupprivilege(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreGroupprivilege rename(String name) {
        return new TCoreGroupprivilege(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreGroupprivilege rename(Name name) {
        return new TCoreGroupprivilege(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TCoreGroupprivilege rename(Table<?> name) {
        return new TCoreGroupprivilege(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroupprivilege where(Condition condition) {
        return new TCoreGroupprivilege(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroupprivilege where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroupprivilege where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroupprivilege where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreGroupprivilege where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreGroupprivilege where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreGroupprivilege where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TCoreGroupprivilege where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroupprivilege whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TCoreGroupprivilege whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
